From 6b3bd4b91aa59bea9b8dc3406438203f807ecf31 Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Thu, 4 May 2017 15:09:35 -0700
Subject: [PATCH 07/22] ipc-router-usb-xprt: Addressing comments from
 code-review

Code review:
https://crd-fisheye.qualcomm.com/fisheye/cru/UT-APPS-AT-KERNEL-7
Addressing all the code review comments

Signed-off-by: Pranav Desai <pranavd@qti.qualcomm.com>
---
 drivers/soc/qcom/ipc_router_usb_xprt.c | 50 +++++++++++++++++++++-------------
 1 file changed, 31 insertions(+), 19 deletions(-)

diff --git a/drivers/soc/qcom/ipc_router_usb_xprt.c b/drivers/soc/qcom/ipc_router_usb_xprt.c
index ce94351..a21bc46 100644
--- a/drivers/soc/qcom/ipc_router_usb_xprt.c
+++ b/drivers/soc/qcom/ipc_router_usb_xprt.c
@@ -115,6 +115,9 @@ static void ipc_router_usb_set_xprt_version(
 	if (!xprt)
 		return;
 	usb_xprtp = container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
+
+	if (!usb_xprtp)
+		return;
 	usb_xprtp->xprt_version = version;
 }
 
@@ -133,6 +136,9 @@ static int msm_ipc_router_usb_get_xprt_version(
 		return -EINVAL;
 	usb_xprtp = container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
 
+	if (!usb_xprtp)
+		return -EINVAL;
+
 	return (int)usb_xprtp->xprt_version;
 }
 
@@ -150,6 +156,9 @@ static int msm_ipc_router_usb_get_xprt_option(
 		return -EINVAL;
 	usb_xprtp = container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
 
+	if (!usb_xprtp)
+		return -EINVAL;
+
 	return (int)usb_xprtp->xprt_option;
 }
 
@@ -166,6 +175,9 @@ static int msm_ipc_router_usb_remote_write_avail(
 	struct msm_ipc_router_usb_xprt *usb_xprtp =
 		container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
 
+	if (!usb_xprtp)
+		return -EINVAL;
+
 	mutex_lock(&usb_xprtp->xprt_lock);
 	if (usb_xprtp->ops && usb_xprtp->xprt_avail)
 		write_avail = usb_xprtp->ops->max_write_size;
@@ -198,6 +210,9 @@ static int msm_ipc_router_usb_remote_write(void *data,
 	}
 
 	usb_xprtp = container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
+	if (!usb_xprtp)
+		return -EINVAL;
+
 	mutex_lock(&usb_xprtp->xprt_lock);
 	if (!usb_xprtp->xprt_avail) {
 		IPC_RTR_ERR("%s: Trying to write on a reset link\n", __func__);
@@ -221,6 +236,7 @@ static int msm_ipc_router_usb_remote_write(void *data,
 	skb = skb_peek(pkt->pkt_fragment_q);
 	if (!skb) {
 		IPC_RTR_ERR("%s SKB is NULL\n", __func__);
+		mutex_unlock(&usb_xprtp->xprt_lock);
 		return -EINVAL;
 	}
 	DBG("%s: About to write %d bytes\n", __func__, len);
@@ -264,10 +280,12 @@ static int msm_ipc_router_usb_remote_close(
 {
 	struct msm_ipc_router_usb_xprt *usb_xprtp;
 
-	DBG("%s -- Enter \n",__func__);
+	DBG("%s \n",__func__);
 	if (!xprt)
 		return -EINVAL;
 	usb_xprtp = container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
+	if (!usb_xprtp)
+		return -EINVAL;
 
 	mutex_lock(&usb_xprtp->xprt_lock);
 	usb_xprtp->xprt_avail = 0;
@@ -297,6 +315,8 @@ static void usb_xprt_read_data(struct work_struct *work)
 	struct delayed_work *rwork = to_delayed_work(work);
 	struct msm_ipc_router_usb_xprt *usb_xprtp =
 		container_of(rwork, struct msm_ipc_router_usb_xprt, read_work);
+	if (!usb_xprtp)
+		return -EINVAL;
 
 	while (1) {
 		while (!usb_xprtp->in_pkt) {
@@ -327,6 +347,7 @@ static void usb_xprt_read_data(struct work_struct *work)
 				mutex_unlock(&usb_xprtp->xprt_lock);
 				IPC_RTR_ERR("%s: Trying to read on "
 						"a reseted link\n", __func__);
+				kfree_skb(skb);
 				goto out_read_data;
 			}
 			mutex_unlock(&usb_xprtp->xprt_lock);
@@ -368,7 +389,7 @@ static void usb_xprt_read_data(struct work_struct *work)
 		msm_ipc_router_xprt_notify(&usb_xprtp->xprt,
 			IPC_ROUTER_XPRT_EVENT_DATA, (void *)usb_xprtp->in_pkt);
 		usb_xprtp->send_to_ipc_core++;
-		release_pkt(usb_xprtp->in_pkt);
+		release_pkt(usb_xptp->in_pkt);
 		usb_xprtp->in_pkt = NULL;
 	}
 out_read_data:
@@ -388,6 +409,9 @@ static void usb_xprt_sft_close_done(struct msm_ipc_router_xprt *xprt)
 	struct msm_ipc_router_usb_xprt *usb_xprtp =
 		container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
 
+	if (!usb_xprtp)
+		return -EINVAL;
+
 	if (unlikely(!usb_xprtp)) {
 		IPC_RTR_ERR("%s: USB Xprt NULL pointer ",__func__);
 		return;
@@ -410,7 +434,7 @@ int msm_ipc_router_usb_ipc_xprt_unregister(struct usb_ipc_xprt_ops *xprt_ops)
 {
 	struct msm_ipc_router_usb_xprt *usb_xprtp = usb_xprt_ctx;
 
-	DBG("%s -- Enter \n",__func__);
+	DBG("%s \n",__func__);
 	if (unlikely(!usb_xprtp)) {
 		IPC_RTR_ERR("%s: USB Xprt NULL pointer ",__func__);
 		return -EINVAL;
@@ -457,7 +481,7 @@ int msm_ipc_router_usb_ipc_xprt_register(struct usb_ipc_xprt_ops *xprt_ops)
 	int rc;
 	struct msm_ipc_router_usb_xprt *usb_xprtp = usb_xprt_ctx;
 
-	DBG("%s -- Enter \n",__func__);
+	DBG("%s \n",__func__);
 
 	if (unlikely(!usb_xprtp)) {
 		IPC_RTR_ERR("%s: USB Xprt NULL pointer ",__func__);
@@ -520,7 +544,7 @@ static int msm_ipc_router_usb_config_init(
 {
 	struct msm_ipc_router_usb_xprt *usb_xprtp;
 
-	DBG("%s: Begin \n", __func__);
+	DBG("%s: \n", __func__);
 	if (unlikely(usb_xprt_ctx)) {
 		IPC_RTR_ERR("%s: Already Inited \n", __func__);
 		return -1;
@@ -534,8 +558,6 @@ static int msm_ipc_router_usb_config_init(
 		return -ENOMEM;
 	}
 
-	IPC_RTR_ERR("%s: usb_xprtp %p \n", __func__, usb_xprtp);
-
 	usb_xprt_ctx = usb_xprtp;
 
 	usb_xprtp->xprt.link_id = usb_xprt_config->link_id;
@@ -573,8 +595,6 @@ static int msm_ipc_router_usb_config_init(
 
 	usb_xprtp->pdev = pdev;
 
-	IPC_RTR_ERR("%s:%d \n", __func__,__LINE__);
-
 	return 0;
 
 }
@@ -597,16 +617,12 @@ static int parse_devicetree(struct device_node *node,
 	const char *ch_name;
 	const char *remote_ss;
 
-	IPC_RTR_ERR("%s: Begin \n", __func__);
-
 	key = "qcom,ch-name";
 	ch_name = of_get_property(node, key, NULL);
 	if (!ch_name)
 		goto error;
 	strlcpy(usb_xprt_config->ch_name, ch_name, IPC_XPRT_NAME_LEN);
 
-	IPC_RTR_ERR("%s: %s=%s \n", __func__,key,ch_name);
-
 	key = "qcom,xprt-remote";
 	remote_ss = of_get_property(node, key, NULL);
 	if (!remote_ss)
@@ -653,7 +669,7 @@ static int msm_ipc_router_usb_xprt_probe(
 	int ret;
 	struct msm_ipc_router_usb_xprt_config usb_xprt_config;
 
-	IPC_RTR_ERR("%s: Begin \n", __func__);
+	IPC_RTR_ERR("%s: \n", __func__);
 	if (pdev && pdev->dev.of_node) {
 		ret = parse_devicetree(pdev->dev.of_node,
 						&usb_xprt_config);
@@ -662,7 +678,6 @@ static int msm_ipc_router_usb_xprt_probe(
 								__func__);
 			return ret;
 		}
-		IPC_RTR_ERR("%s:%d \n", __func__,__LINE__);
 
 		ret = msm_ipc_router_usb_config_init(
 						&usb_xprt_config, pdev);
@@ -670,7 +685,6 @@ static int msm_ipc_router_usb_xprt_probe(
 			IPC_RTR_ERR(" %s init failed\n", __func__);
 			return ret;
 		}
-		IPC_RTR_ERR("%s:%d \n", __func__,__LINE__);
 	}
 	return ret;
 }
@@ -684,8 +698,6 @@ static ssize_t usb_ipc_xprt_debugfs_read(struct file *file,
 			(struct msm_ipc_router_usb_xprt *)file->private_data;
 	ssize_t ret_cnt;
 
-	DBG("%s -- Enter \n", __func__);
-
 	if (unlikely(!usb_xprtp)) {
 		IPC_RTR_ERR("%s: USB Xprt NULL pointer ",__func__);
 		return -EINVAL;
@@ -777,7 +789,7 @@ static int __init msm_ipc_router_usb_xprt_init(void)
 {
 	int rc;
 
-	IPC_RTR_ERR("%s: Begin \n", __func__);
+	IPC_RTR_ERR("%s: \n", __func__);
 	rc = platform_driver_register(&msm_ipc_router_usb_xprt_driver);
 	if (rc) {
 		IPC_RTR_ERR(
-- 
1.8.2.1

